OGRE-Next: Ogre::DistanceLodStrategyBase Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::DistanceLodStrategyBase Class Referenceabstract
Core » LOD

Level of detail strategy based on distance from camera. More...

`#include <OgreDistanceLodStrategy.h>`

Inheritance diagram for Ogre::DistanceLodStrategyBase:
[legend]

## Public Member Functions
| DistanceLodStrategyBase (const String &name)
| Default constructor.
Real | getBaseValue () const override
| Get the value of the first (highest) level of detail.
virtual Real | getSquaredDepth (const MovableObject *movableObject, const Ogre::Camera *camera) const =0
| Get the squared depth from camera to the LOD object.
bool | isReferenceViewEnabled () const
| Determine if use of the reference view is enabled.
void | lodUpdateImpl (const size_t numNodes, ObjectData t, const Camera *camera, Real bias) const override
void | setReferenceView (Real viewportWidth, Real viewportHeight, Radian fovY)
| Sets the reference view upon which the distances were based.
void | setReferenceViewEnabled (bool value)
| Enables to disables use of the reference view.
Real | transformBias (Real factor) const override
| Transform LOD bias so it only needs to be multiplied by the LOD value.
Real | transformUserValue (Real userValue) const override
| Transform user supplied value to internal value.
Public Member Functions inherited from Ogre::LodStrategy
| LodStrategy (const String &name)
| Constructor accepting name.
virtual | ~LodStrategy ()
| Virtual destructor.
const String & | getName () const
| Get the name of this strategy.
Real | getValue (const MovableObject *movableObject, const Camera *camera) const
| Compute the LOD value for a given movable object relative to a given camera.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::LodStrategy
static void | lodSet (ObjectData &t, Real lodValues[ARRAY_PACKED_REALS])

## Detailed Description

Level of detail strategy based on distance from camera.

This is an abstract base class for DistanceLodBoxStrategy and DistanceLodSphereStrategy.

Remarks
  The purpose of the reference view is to ensure a consistent experience for all users. Monitors of different resolutions and aspect ratios will each have different results for the distance queries.

  It depends on gameplay testing. If all testers had 16:9 monitors and 110° FOV, then that's the value you should enter (to ensure as much as possible the experience stays consistent for all other users who don't have a 16:9 monitor and/or use a different FOV).

  If all your testers had 4:3 monitors, then enter a 4:3 resolution.

  If all your testers had varying resolutions or you just didn't care, then this feature is useless for you and should be disabled (default: disabled).

## Constructor & Destructor Documentation

## ◆ DistanceLodStrategyBase()

Ogre::DistanceLodStrategyBase::DistanceLodStrategyBase | ( | const String & | name | ) |

Default constructor.

## Member Function Documentation

## ◆ getBaseValue()

Real Ogre::DistanceLodStrategyBase::getBaseValue | ( |  | ) | const
| overridevirtual

Get the value of the first (highest) level of detail.

Implements Ogre::LodStrategy.

## ◆ getSquaredDepth()

virtual Real Ogre::DistanceLodStrategyBase::getSquaredDepth | ( | const MovableObject * | movableObject,
|  | const Ogre::Camera * | camera ) const
| pure virtual

Get the squared depth from camera to the LOD object.

Implemented in Ogre::DistanceLodBoxStrategy, and Ogre::DistanceLodSphereStrategy.

## ◆ isReferenceViewEnabled()

bool Ogre::DistanceLodStrategyBase::isReferenceViewEnabled | ( |  | ) | const

Determine if use of the reference view is enabled.

## ◆ lodUpdateImpl()

void Ogre::DistanceLodStrategyBase::lodUpdateImpl | ( | const size_t | numNodes,
|  | ObjectData | t,
|  | const Camera * | camera,
|  | Real | bias ) const
| overridevirtual

Implements Ogre::LodStrategy.

## ◆ setReferenceView()

void Ogre::DistanceLodStrategyBase::setReferenceView | ( | Real | viewportWidth,
|  | Real | viewportHeight,
|  | Radian | fovY )

Sets the reference view upon which the distances were based.

Note
  This automatically enables use of the reference view.
  There is no corresponding get method for these values as they are not saved, but used to compute a reference value.

## ◆ setReferenceViewEnabled()

void Ogre::DistanceLodStrategyBase::setReferenceViewEnabled | ( | bool | value | ) |

Enables to disables use of the reference view.

Note
  Do not enable use of the reference view before setting it.

## ◆ transformBias()

Real Ogre::DistanceLodStrategyBase::transformBias | ( | Real | factor | ) | const
| overridevirtual

Transform LOD bias so it only needs to be multiplied by the LOD value.

Implements Ogre::LodStrategy.

## ◆ transformUserValue()

Real Ogre::DistanceLodStrategyBase::transformUserValue | ( | Real | userValue | ) | const
| overridevirtual

Transform user supplied value to internal value.

Remarks
  By default, performs no transformation.
  Do not throw exceptions for invalid values here, as the LOD strategy may be changed such that the values become valid.

Reimplemented from Ogre::LodStrategy.

The documentation for this class was generated from the following file:

- OgreDistanceLodStrategy.h